/*
 * This software is the confidential and proprietary information of
 * Smardec. You shall not disclose or distribute such Confidential Information.
 * This software shall not be integrated, copied (partially or fully),
 * or reverse engineered into any other software, program, or code that is
 * not intended for Smardec. You shall use it only in accordance with the terms
 * of the license agreement you entered into with Smardec.
 *
 * Copyright (C) 2004-2006 Smardec. All rights reserved.
 *
 * http://www.smardec.com
 *
 */

package com.smardec.demo.j2native.linux.usermanager;

import com.smardec.demo.j2native.linux.usermanager.info.UserInfo;
import com.smardec.demo.j2native.linux.usermanager.j2n.InfoProvider;
import com.smardec.demo.j2native.tools.Cache;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class UserManager {
    private static UserManager instance;
    private Cache userInfos;

    private UserManager() {
        userInfos = new Cache();
    }

    public static UserManager getInstance() {
        if (instance == null) {
            instance = new UserManager();
        }
        return instance;
    }

    public UserInfo getUserInfo(int id) {
        return UserInfo.clone((UserInfo) userInfos.get(new Integer(id)));
    }

    public UserInfo getUserInfo(String userName) {
        return UserInfo.clone((UserInfo) userInfos.get(userName));
    }

    public UserInfo[] getUserInfos() {
        List infosList = new ArrayList();
        Iterator iterator = userInfos.iterator();
        while (iterator.hasNext()) {
            UserInfo ui = (UserInfo) iterator.next();
            if (ui != null) {
                infosList.add(UserInfo.clone((UserInfo) ui));
            }
        }
        return (UserInfo[]) infosList.toArray(new UserInfo[infosList.size()]);
    }

    public boolean setUserInfo(UserInfo userInfo) {
        return false;
    }

    public void refresh() {
        userInfos.clear();
        InfoProvider infoProvider = InfoProvider.getInfoProvider();
        List users = infoProvider.getAllUsers();
        for (int i = users.size() - 1; i >= 0; i--) {
            UserInfo userInfo = (UserInfo) users.get(i);
            userInfos.put(new Integer(userInfo.getId()), userInfo);
            userInfos.put(userInfo.getUserName(), userInfo);
        }
    }
}

